package com.game.business.dto;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.game.common.annotation.Excel;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;

@Data
@ApiModel("代理团队")
public class AppAgentTeamDto implements Serializable {

    private static final long serialVersionUID = 1L;

    /** 用户id */
    @ApiModelProperty(value = "用户id")
    @Excel(name = "用户id")
    private Long userId;

    @JsonIgnore
    private long pid;

    /** 当前记录起始索引 */
    @ApiModelProperty(value = "页数")
    private Integer pageNum;

    /** 每页显示记录数 */
    @ApiModelProperty(value = "每页条数")
    private Integer pageSize;

}
